//*****************************************
//@@ohbPUePWSV qsb@fkbc\vO@uQ
//     PIC16F1847 RTC & Graphic LCD Display Program
//
// File Name:Pic_iic.h
//  wb_[t@C
//
//  RC0(SCL): IIC-SCL
//  RC1(SDA): IIC-SDA
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/02/25  New(TAB4)  Taishi
//  2015/05/09  modify for 16F1847
//*****************************************

#define	IIC_READ		1
#define	IIC_WRITE		0

#define	IIC_ACK			1
#define	IIC_NACK		0

extern	void			iic_init(void);
extern	void			iic_close(void);
extern	void			iic_start(void);
extern	void			iic_restart(void);
extern	void			iic_address(unsigned int dev_id, unsigned int dev_addr, unsigned char rw_type);
extern	void 			iic_stop(void);
extern	void			iic_write(unsigned char data);
extern	unsigned char	iic_read(char ack_type);

