//*****************************************
//@@ohbPUePWSV ZvvO@uQ
//@@ PIC16F1847 AKE MUTU Clock Program
//
// File Name:Rtc_PCF8563.h
//  wb_[t@C
//
// Real Time Clock PCF8563(NXP)
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/02/25  New(TAB4)  Taishi
//  2014/04/30  Modify for 16F1827  Taishi
//  2015/05/09  modify for 16F1847
//*****************************************

#define PCF8563_ID			0xA0	// I2C PCF8563 Device Identifier
#define PCF8563_ADDR		0x02	// I2C PCF8563 Device Address

// qsbAhX
#define	RTC_CONTROL_status1_ADDR_PCF8563		0x00		// Rg[|XeC^XP̃AhX
#define	RTC_CONTROL_status1_TEST1_PCF8563		0x80		// @Rg[|XeC^XP̃rbg
#define	RTC_CONTROL_status1_STOP_PCF8563		0x20		// @Rg[|XeC^XP̃rbg
#define	RTC_CONTROL_status1_TESTC_PCF8563		0x08		// @Rg[|XeC^XP̃rbg
#define	RTC_CONTROL_status2_ADDR_PCF8563		0x01		// Rg[|XeC^XQ̃AhX
#define	RTC_CONTROL_status2_TI_TP_PCF8563		0x10		// @Rg[|XeC^XQ̃rbg
#define	RTC_CONTROL_status2_AF_PCF8563			0x08		// @Rg[|XeC^XQ̃rbg
#define	RTC_CONTROL_status2_TF_PCF8563			0x04		// @Rg[|XeC^XQ̃rbg
#define	RTC_CONTROL_status2_AIE_PCF8563			0x02		// @Rg[|XeC^XQ̃rbg
#define	RTC_CONTROL_status2_TIE_PCF8563			0x01		// @Rg[|XeC^XQ̃rbg
#define	RTC_VL_Second_ADDR_PCF8563				0x02		// bf[^̃AhXiN܂őAhXj
#define	RTC_Second_VL_PCF8563					0x80		// @bf[^̃rbg
#define	RTC_Minutes_ADDR_PCF8563				0x03		// f[^̃AhX
#define	RTC_Hours_ADDR_PCF8563					0x04		// f[^̃AhX
#define	RTC_Days_ADDR_PCF8563					0x05		// f[^̃AhX
#define	RTC_Weekdays_ADDR_PCF8563				0x06		// jf[^̃AhX
#define	RTC_Century_Months_ADDR_PCF8563			0x07		// f[^̃AhX
#define	RTC_Months_C_PCF8563					0x80		// @f[^̃rbg
#define	RTC_Years_ADDR_PCF8563					0x08		// Nf[^̃AhX
#define	RTC_Minutes_alarm_ADDR_PCF8563			0x09		// A[f[^̃AhX
#define	RTC_Minutes_alarm_AE_M_ADDR_PCF8563		0x80		// @A[f[^̃rbg
#define	RTC_Hours_alarm_ADDR_PCF8563			0x0a		// A[f[^̃AhX
#define	RTC_Hours_alarm_AE_H_ADDR_PCF8563		0x80		// @A[f[^̃rbg
#define	RTC_Days_alarm_ADDR_PCF8563				0x0b		// A[f[^̃AhX
#define	RTC_Days_alarm_AE_D_PCF8563				0x80		// @A[f[^̃rbg
#define	RTC_Weekdays_alarm_ADDR_PCF8563			0x0c		// jA[f[^̃AhX
#define	RTC_Weekdays_alarm_AE_W_ADDR_PCF8563	0x80		// jA[f[^̃rbg
#define	RTC_CLKOUT_control_ADDR_PCF8563			0x0d		// NbNo̓f[^̃AhX
#define	RTC_CLKOUT_control_FE_PCF8563			0x80		// @NbNo̓f[^̃rbg
#define	RTC_CLKOUT_control_FD0_PCF8563			0x01		// @NbNo̓f[^̃rbg
#define	RTC_CLKOUT_control_FD1_PCF8563			0x02		// @NbNo̓f[^̃rbg
#define	RTC_Timer_control_ADDR_PCF8563			0x0e		// ^C}[Rg[f[^̃AhX
#define	RTC_Timer_control_TE_PCF8563			0x80		// @^C}[Rg[f[^̃rbg
#define	RTC_Timer_control_TD0_PCF8563			0x01		// @^C}[Rg[f[^̃rbg
#define	RTC_Timer_control_TD1_PCF8563			0x02		// @^C}[Rg[f[^̃rbg
#define	RTC_Timer_ADDR_PCF8563					0x0f		// ^C}[f[^̃AhX

extern	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
extern	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
extern	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
extern	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
extern	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
extern	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
extern	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
extern	unsigned char	gRTC_control;			// qsb Rg[̃f[^
extern	unsigned char	gRTC_status;			// qsb XeC^X̃f[^
extern	unsigned char	gRTC_register_d;		// qsbWX^[0x0d] ̑ւ
extern	unsigned char	gRTC_register_e;		// qsbWX^[0x0e] ̑ւ
extern	unsigned char	gRTC_register_f;		// qsbWX^[0x0f] ̑ւ
extern	unsigned char	rtc_05s_count;			// qsbĂ鎞̂Pboߗp
extern	unsigned char	adj_pass;				// }CiXf[^Ł@xĂ܂}CiX鎖h
extern	signed char		bityousei[24];			// OOQR܂ł̔li|X`{Xje̖ɒl߂KvL
extern	signed char		bityousei_sum;			// l̃T
#ifdef		HARD_TEST							// n[h̃`FbN̎
extern	unsigned char	gRTC_register[16];
#endif

extern	void			rtc_control_read_PCF8563(void);
extern	void 			rtc_control_write_PCF8563(void);
extern	void			rtc_CLKOUT_read_PCF8563(void);
extern	void			rtc_CLKOUT_write_PCF8563(void);
extern	unsigned char	rtc_init_PCF8563(void);
extern	void			rtc_read_PCF8563(void);
extern	void			rtc_reg_read_PCF8563(void);
extern	void			rtc_write_PCF8563(void);
extern	signed char		rtc_adjust_PCF8563(void);
extern	void			wtite_bityousei(void);
extern	signed char		get_bityou_sum(void);
