//*******************************************************
//@@ohbPUePWSV ZvvO@uQ
//@@ PIC16F1827 AKE MUTU Clock Program
//  file name: step_motor.c
//@XebsO[^쓮
//@@@q`RCS@oaQCTɐڑ㎥MgAP|Q㎥ŋ쓮
//
//   MPLAB IDE v8.84  HiTEC C
//   [C:\Program Files\HI-TECH Software\PICC\9.83\include\as16f1847.h] include 
//
//  2015/04/30  New  Programed by Taishi
//  2015/05/09  modify for 16F1847
//*******************************************************

#include	<htc.h>

#include	"16F1847_ake6_clock2.h"
#include	"step_motor.h"

//***************************************************************************************
//@XebsO[^쓮																*
//@FړXebv@́@ړ̐ΈʒuiO`#Step_of_RoundAő͂P̃Xebvj	*
//@F]@PivjAOivj						*
//@FΈʒuړ@P݈ʒu܂ňړAOΈʒuړ						*
//@F@Pi݈ʒuOʒuƂAړȂj				*
//@@Ṕ@P|Q́@Q㎥ŋ쓮 
//***************************************************************************************
void	step_move(unsigned short n, unsigned char cw, unsigned char abs, unsigned char init)
{
	static unsigned short	pos_abs = 0;			// Έʒu
	static unsigned char	pls_num = 0;
	const	unsigned char	pls_mask_PA=0b11100111;
	const	unsigned char	pls_mask_PB=0b11011011;
#ifdef	Drive_1_2									// P|Q㎥
	const	unsigned char	pls_data_PA[8]={0b00001000,0b00011000,0b00010000,0b00010000,0b00000000,0b00000000,0b00000000,0b00001000};
	const	unsigned char	pls_data_PB[8]={0b00000000,0b00000000,0b00000000,0b00000100,0b00000100,0b00100100,0b00100000,0b00100000};
#else
 #ifdef Drive_2										// Q㎥
	const	unsigned char	pls_data_PA[4]={0b00011000,0b00010000,0b00000000,0b00001000};
	const	unsigned char	pls_data_PB[4]={0b00000000,0b00000100,0b00100100,0b00100000};
 #else												// P㎥
	const	unsigned char	pls_data_PA[4]={0b00001000,0b00010000,0b00000000,0b00000000};
	const	unsigned char	pls_data_PB[4]={0b00000000,0b00000000,0b00000100,0b00100000};
 #endif
#endif
	unsigned short			ui;
	unsigned short			pls_count;

	if(init == 1){									// ̎
		pos_abs = 0;
	}else{
		if(abs == 1){								// Έʒuw̎
			if(cw == 1){							// v]
				if(pos_abs <= n){					// @ʒu傫
					pls_count = (n - pos_abs);
				}else{								// @ʒu
					pls_count = (Step_of_Round - pos_abs + n);
				}
			}else{									// v]
				if(pos_abs <= n){					// @ʒu傫
					pls_count = (Step_of_Round - n + pos_abs);
				}else{								// @ʒu
					pls_count = (pos_abs - n);
				}
			}
		}else{
			pls_count = n;
		}

		if(pls_count != 0){
			led_on();							//  LED ON
			for(ui = 0; ui < pls_count; ui++){
#if		CW_CCW == 1								// PF猩Ăbv
				if(cw == 1){
					pls_num--;
				}else{
					pls_num++;
				}
#else
				if(cw == 1){
					pls_num++;
				}else{
					pls_num--;
				}
#endif

#ifdef	Drive_1_2								// P|Q㎥
				pls_num &= 0x07;
#else											// Ṕ@Q㎥
				pls_num &= 0x03;
#endif

#ifdef	Drive_1									// P㎥
				__delay_ms(10);					//	POҋ@iP㎥ł͂POrɂȂƒEj
#else
				__delay_ms(5);					//	Tҋ@;
#endif

				PORTA &= pls_mask_PA;			//	pXneeio`j
				PORTB &= pls_mask_PB;			//	pXneeioaj
				PORTA |= pls_data_PA[pls_num];	//	pXóio`j
				PORTB |= pls_data_PB[pls_num];	//	pXóioaj

				if(cw == 1){
					pos_abs++;
					if(Step_of_Round <= pos_abs){
						pos_abs = 0;
					}
				}else{
					pos_abs--;
					if(Step_of_Round <= pos_abs){
						pos_abs = (Step_of_Round - 1);
					}
				}
#ifdef	Drive_1									// P㎥
				__delay_ms(10);					//	POҋ@iP㎥ł͂POrɂȂƒEj
#else
				__delay_ms(5);					//	Tҋ@
#endif
			}
			PORTA &= pls_mask_PA;				//	pXneeio`j
			PORTB &= pls_mask_PB;				//	pXneeioaj
			led_off();							//  LED OFF
		}
	}

}
