//*****************************************
//@@ohbPUePWSV ZvvO@uQ
//		 PIC16F1847 AKE 6 Clock Program
//
// File Name:port_bit.c
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/02/25  New(TAB4)  Taishi
//  2014/04/30  Modify for 16F1827  Taishi
//  2015/05/09  modify for 16F1847
//*****************************************

#include	<htc.h>

#include	"16F1847_ake6_clock2.h"
#include	"port_bit.h"


unsigned char	gTim_10ms_sw;				// XCb`pPOrPʃ^C}[
unsigned char	gTim_10ms_sw1_length;		// EXCb`pԂPOrPʃ^C}[
unsigned char	gTim_10ms_sw1_continue;		// EXCb`pAPOrPʃ^C}[
unsigned char	gTim_10ms_sw2_length;		// XCb`pԂPOrPʃ^C}[
unsigned char	gTim_10ms_sw2_continue;		// XCb`pAPOrPʃ^C}[
unsigned char	sw[4];						// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;

//***************************
//@XCb`(RB7,6)̊ݐݒ
//@
//@@F@OݕsA@P݉
//***************************
void	sw_interrupt_set(unsigned char enable)
{
	// RA4 Interrupt Initial
	if(enable == 1){						// ݉̎
		gSet_time = 0;
		gSet_pos = 0;
		IOCBP6 = 0;							// GbW
		IOCBN6 = 1;							// GbWL
		IOCBP7 = 0;							// GbW
		IOCBN7 = 1;							// GbWL
		IOCBF = 0;							// tONA
		IOCIE = 1;							// ݉
	}else{									// ݕs̎
		IOCBP6 = 0;							// GbW
		IOCBN6 = 0;							// GbWL
		IOCBP7 = 0;							// GbW
		IOCBN7 = 1;							// GbWL
		IOCBF = 0;							// tONA
		IOCIE = 0;							// ݕs
		gSet_pos = 0;
		gSet_time = 0;
	}
}
//***************************
//@XCb`̏ݒ
//***************************
void	sw_init(void)
{
	TRISB |= 0b11000000;		//	o͕ݒ(RB6,7:Input)
	WPUA  |= 0b11000000;		//	vAbvݒ(RB6,7:Pullup)
}
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(gTim_10ms_sw == 0){
		gTim_10ms_sw = 2;					// QOrԊu
		uc = ((~PORTB) & 0b11000000);		// ]XCb`f[^擾
		if (old_sw == uc){					// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}
#define			TMR_LONG			100			// 10mSx200=2Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE_FIRST	100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE		20			// 10mSx20=200mS ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//***************************
unsigned char	get_action_sw(void)
{
	unsigned char	uc=0;

	get_sw();										//@XCb`Ԃ

	if((sw[2] & 0b01000000) != 0){					// EXCb`nm̏uԂ̎
		uc |= SW1_ON;
		gTim_10ms_sw1_continue = TMR_CONTIMUE_FIRST;
		gTim_10ms_sw1_length = TMR_LONG;
	}else if((sw[1] & 0b01000000) != 0){			// EXCb`nm̎
		if(gTim_10ms_sw1_continue == 0){				// ꑱo^C~O̎
			uc |= SW1_ON_CONTINUE;
			gTim_10ms_sw1_continue = TMR_CONTIMUE;
		}
	}else if((sw[3] & 0b01000000) != 0){			// EXCb`ꂽuԂ̎
		if(gTim_10ms_sw1_length == 0){				// ꂽԂ
			uc |= SW1_OFF_LONG;
		}else{										// ꂽԂZ
			uc |= SW1_OFF_SHORT;
		}
		gTim_10ms_sw1_continue = 0;
		gTim_10ms_sw1_length = 0;
	}else if((sw[1] & 0b01000000) == 0){			// EXCb`nee̎
		gTim_10ms_sw1_continue = 0;
		gTim_10ms_sw1_length = 0;
	}

	if((sw[2] & 0b10000000) != 0){					// XCb`nm̏uԂ̎
		uc |= SW2_ON;
		gTim_10ms_sw2_continue = TMR_CONTIMUE_FIRST;
		gTim_10ms_sw2_length = TMR_LONG;
	}else if((sw[1] & 0b10000000) != 0){			// EXCb`nm̎
		if(gTim_10ms_sw2_continue == 0){				// ꑱo^C~O̎
			uc |= SW2_ON_CONTINUE;
			gTim_10ms_sw2_continue = TMR_CONTIMUE;
		}
	}else if((sw[3] & 0b10000000) != 0){			// EXCb`ꂽuԂ̎
		if(gTim_10ms_sw2_length == 0){				// ꂽԂ
			uc |= SW2_OFF_LONG;
		}else{										// ꂽԂZ
			uc |= SW2_OFF_SHORT;
		}
		gTim_10ms_sw2_continue = 0;
		gTim_10ms_sw2_length = 0;
	}else if((sw[1] & 0b10000000) == 0){			// EXCb`nee̎
		gTim_10ms_sw2_continue = 0;
		gTim_10ms_sw2_length = 0;
	}

	return(uc);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if(((~PORTB) & 0b11000000) == 0){;		// PxڃXCb`f[^nee
			wait_10ms(10);						// 100mS Delay
			if(((~PORTB) & 0b11000000) == 0){;	// QxڃXCb`f[^nee
				break;							// {ɗꂽƂ
			}
		}
	}
}
